/* increment the first byte of a file by 1 */
/* usage: mapper3 file [flag] */
#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>

#define BASE 0
#define SIZE 10

#ifndef MAP_FAILED
#define MAP_FAILED ((void *)-1)
#endif

int
main(int argc, char *argv[])
{
  int fd, i;
  caddr_t pa;

  fd = open(argv[1], O_RDWR);
  if (fd < 0) {
    perror(argv[1]);
    exit(1);
  }
  printf("opened file %s\n", argv[1]);

  pa = mmap((caddr_t) 0,
	    SIZE,
	    (PROT_READ | PROT_WRITE),
	    MAP_SHARED,
	    fd,
	    BASE);
  if (pa == MAP_FAILED) {
    perror("mmap");
    exit(1);
  }
  printf("file is mapped with address 0x%x\n", (u_int) pa);
  close(fd);
  printf("closed file %s\n", argv[1]);

  fd = open(argv[1], O_RDWR);
  if (fd < 0) {
    perror(argv[1]);
    exit(1);
  }
  printf("opened file %s\n", argv[1]);
  close(fd);
  printf("closed file %s\n", argv[1]);

#if 1
  for (i = 0; i < SIZE; ++i) {
    printf("\tbyte %2d is %3d (%c)\n", i, pa[i],
	   isprint((int)pa[i]) ? pa[i] : '.');
  }

  /* hack to modify one byte in the mapped page */
  if (argc > 2) {
    printf("trying to modify the page...\n");
    pa[0] += 1;
    printf("waiting...");
    getchar();
  }
#endif
  if (munmap(pa, SIZE) < 0) {
    perror("munmap");
    exit(1);
  }
  printf("file is unmapped\n");

  exit(0);
}
