#include <stdio.h>
#include <fcntl.h>
#include <memory.h>
#include <stdlib.h>
#include <unistd.h>

int
main(int argc, char *argv[])
{
  int fd, ret;
  char *buf;
  char *filename;
  int filesize;

  if (argc != 3) {
    printf("usage: %s filename size\n", argv[0]);
    exit(1);
  }
  filename = argv[1];
  filesize = atoi(argv[2]);
  buf = malloc(filesize);
  if (!buf) {
    perror("malloc");
    exit(1);
  }
  fd = open(filename, O_WRONLY | O_CREAT, 0664);
  if (fd < 0) {
    perror(filename);
    exit(1);
  }
  memset(buf, 0, filesize);
  ret = write(fd, buf, filesize);
  if (ret != filesize) {
    fprintf(stdout, "write returned %d\n", ret);
    perror("write");
  }
  close(fd);
  exit(0);
}
